blob: c311933401081fd48b5451605ff3a4a11f4893da [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070038 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
58# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070059# ${1} - output file
60# ${@:2} - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020061vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100064 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020065
66 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100067 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090068 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100069 --no-whole-archive \
70 --start-group \
71 ${KBUILD_VMLINUX_LIBS} \
72 --end-group \
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070073 ${@:2}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100074
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070075 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${1} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100076 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020077 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090079 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100080 -Wl,--no-whole-archive \
81 -Wl,--start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 -Wl,--end-group \
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070084 ${@:2}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100085
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070086 ${CC} ${CFLAGS_vmlinux} -o ${1} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100087 -Wl,-T,${lds} \
88 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100089 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020090 rm -f linux
91 fi
92}
93
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070094# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070095# ${1} - vmlinux image
96# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070097gen_btf()
98{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070099 local pahole_ver
100 local bin_arch
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700101
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700102 if ! [ -x "$(command -v ${PAHOLE})" ]; then
103 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700104 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700105 fi
106
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700107 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
108 if [ "${pahole_ver}" -lt "113" ]; then
109 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700110 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700111 fi
112
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700113 info "BTF" ${2}
114 vmlinux_link ${1}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700115 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700116
117 # dump .BTF section into raw binary file to link with final vmlinux
118 bin_arch=$(${OBJDUMP} -f ${1} | grep architecture | \
119 cut -d, -f1 | cut -d' ' -f2)
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700120 ${OBJCOPY} --dump-section .BTF=.btf.vmlinux.bin ${1} 2>/dev/null
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700121 ${OBJCOPY} -I binary -O ${CONFIG_OUTPUT_FORMAT} -B ${bin_arch} \
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700122 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700123}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200124
125# Create ${2} .o file with all symbols from the ${1} object file
126kallsyms()
127{
128 info KSYM ${2}
129 local kallsymopt;
130
131 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100132 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200133 fi
134
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700135 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030136 kallsymopt="${kallsymopt} --absolute-percpu"
137 fi
138
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700139 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
140 kallsymopt="${kallsymopt} --base-relative"
141 fi
142
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200143 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
144 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200145
Ard Biesheuvela0439342016-02-05 11:25:05 +0100146 local afile="`basename ${2} .o`.S"
147
148 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
149 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200150}
151
152# Create map file with all symbols from ${1}
153# See mksymap for additional details
154mksysmap()
155{
156 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
157}
158
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700159sortextable()
160{
161 ${objtree}/scripts/sortextable ${1}
162}
163
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200164# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200165cleanup()
166{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700167 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200168 rm -f .tmp_System.map
169 rm -f .tmp_kallsyms*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200170 rm -f .tmp_vmlinux*
171 rm -f System.map
172 rm -f vmlinux
173 rm -f vmlinux.o
174}
175
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000176on_exit()
177{
178 if [ $? -ne 0 ]; then
179 cleanup
180 fi
181}
182trap on_exit EXIT
183
184on_signals()
185{
186 exit 1
187}
188trap on_signals HUP INT QUIT TERM
189
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200190#
191#
192# Use "make V=1" to debug this script
193case "${KBUILD_VERBOSE}" in
194*1*)
195 set -x
196 ;;
197esac
198
199if [ "$1" = "clean" ]; then
200 cleanup
201 exit 0
202fi
203
204# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900205. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200206
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200207# Update version
208info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900209if [ -r .version ]; then
210 VERSION=$(expr 0$(cat .version) + 1)
211 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200212else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900213 rm -f .version
214 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200215fi;
216
217# final build of init/
Cao jina7b151f2018-02-21 12:25:07 +0800218${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200219
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100220#link vmlinux.o
221info LD vmlinux.o
222modpost_link vmlinux.o
223
224# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900225${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100226
Alexey Gladkov898490c2019-04-29 18:11:14 +0200227info MODINFO modules.builtin.modinfo
228${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
229
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700230btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700231if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700232 if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
233 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700234 fi
235fi
236
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200237kallsymso=""
238kallsyms_vmlinux=""
239if [ -n "${CONFIG_KALLSYMS}" ]; then
240
241 # kallsyms support
242 # Generate section listing all symbols and add it into vmlinux
243 # It's a three step process:
244 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
245 # but __kallsyms is empty.
246 # Running kallsyms on that gives us .tmp_kallsyms1.o with
247 # the right size
248 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
249 # the right size, but due to the added section, some
250 # addresses have shifted.
251 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100252 # 3) That link may have expanded the kernel image enough that
253 # more linker branch stubs / trampolines had to be added, which
254 # introduces new names, which further expands kallsyms. Do another
255 # pass if that is the case. In theory it's possible this results
256 # in even more stubs, but unlikely.
257 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
258 # other bugs.
259 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200260 #
261 # a) Verify that the System.map from vmlinux matches the map from
262 # ${kallsymso}.
263
264 kallsymso=.tmp_kallsyms2.o
265 kallsyms_vmlinux=.tmp_vmlinux2
266
267 # step 1
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700268 vmlinux_link .tmp_vmlinux1 ${btf_vmlinux_bin_o}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200269 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
270
271 # step 2
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700272 vmlinux_link .tmp_vmlinux2 .tmp_kallsyms1.o ${btf_vmlinux_bin_o}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200273 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
274
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100275 # step 3
Michael Forneya670b0b2018-03-18 17:54:02 -0700276 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
277 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100278
279 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200280 kallsymso=.tmp_kallsyms3.o
281 kallsyms_vmlinux=.tmp_vmlinux3
282
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700283 vmlinux_link .tmp_vmlinux3 .tmp_kallsyms2.o ${btf_vmlinux_bin_o}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200284 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
285 fi
286fi
287
288info LD vmlinux
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700289vmlinux_link vmlinux "${kallsymso}" "${btf_vmlinux_bin_o}"
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700290
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700291if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
292 info SORTEX vmlinux
293 sortextable vmlinux
294fi
295
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200296info SYSMAP System.map
297mksysmap vmlinux System.map
298
299# step a (see comment above)
300if [ -n "${CONFIG_KALLSYMS}" ]; then
301 mksysmap ${kallsyms_vmlinux} .tmp_System.map
302
303 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200304 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200305 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200306 exit 1
307 fi
308fi